% ------------------------------------------------------------------------
% EVCLUS : Clustering of relational data
%       BUTTERFLY EXAMPLE
% ------------------------------------------------------------------------
% T. Denoeux & M. Masson June 2002

clear
x=[-5 0   % the data
   -3.34 1.67
   -3.34 0
   -3.34 -1.67
   -1.67 0
   0 0
   1.67 0
   3.34 -1.67
   3.34 0
   3.34 +1.67
   5 0 ];

n=size(x,1);

% Display of data
figure(1);clf
t=plot(x(:,1),x(:,2),'+');
set(t,'MarkerSize',10);
hold on
for i=1:n,t=text(x(i,1)-0.1,x(i,2)+0.4,num2str(i));
set(t,'FontSize',12);
end;
set(gca,'FontSize',12);
drawnow

% Distances calculation

D=x*x';
N=diag(diag(D))*ones(size(D));
D=(N+N'-2*D);
D=round(D);
n=size(D,1),

% Run of EVCLUS
c=2; % number of clusters
version=1; % focal elements= singletons + empty set + Omega
lambda=0.05; % regularization parameter
[mass,F,alpha,K,Stress,H]=EVCLUS(D,c,lambda,version);

% Display of results
figure(2);
plot(mass);
legend('c1','c2','empty set','omega');
ylabel('mass of belief');
xlabel('point #');


